Imports System
Imports System.Text

Module Program
    'skomponowana tabela
    Dim composedTable As New List(Of String)
    'tabela startowa, jej modyfikacja utrudnia zamanie szyfru
    Dim startTable As New List(Of String)(New String() {"A", "B", "C", "D", "E",
                                                        "F", "G", "H", "I", "K",
                                                        "L", "M", "N", "O", "P",
                                                        "Q", "R", "S", "T", "W",
                                                        "U", "V", "X", "Y", "Z"})
    'tekst do ukrycia lub odszyfrowania
    Dim hiddenText As String
    'tekst po zaszyfrowaniu
    Dim textAfterEncription As String
    'tekst po odszyfrowaniu 
    Dim textAfterDecription As String

    Sub Main(args As String())
        ''''proste menu uytkownika
        Console.WriteLine("Co chesz zrobi? Wpisz cyfr zadania." + vbNewLine + "1.Zaszyfruj tekst." _
                          + vbNewLine + "2.Odszyfruj tekst.")
        Dim zad As String
        Do
            zad = Console.ReadLine()
            If zad = "1" Or zad = "2" Then
                Exit Do
            Else
                Console.WriteLine("moesz wybra tylko cyfr 1 lub 2.")
            End If
        Loop
        '''''
        If zad = 1 Then
            'uytkownik chce zaszyfrowa tekst
            Console.Write("Wprowad tekst do ukrycia: ")
            'pobierz tekst do zaszyfrowania od uytkownika
            hiddenText = formatText(textFromConsole(), False)
            'wywietl uytkownikowi tekst po formatowaniu
            '--zamienia polskie znaki, uswa spacje, przecinki ip
            displayFormatedText(hiddenText)
            'pobiera od uytkownika haso do szyfrowania
            Console.Write("Wprowad haso: ")
            Dim klucz As String = Console.ReadLine()
            'formatuje klucz
            klucz = formatText(klucz, True)
            'uswa powtarzajce si litery
            klucz = formatKey(klucz)
            'wywietla sformatowany klucz
            Console.Write("Twoje haso po formatowaniu: " + klucz + vbNewLine)
            'generuje i wywietla sformatowan tabele
            Console.Write(vbNewLine + "Tabela szyfrujca:" + vbNewLine)
            composedTable = generatePlayFairTable(klucz)
            displayTable()
            'szyfruje i wywietla zaszyfrowan wiadomo
            Console.Write(vbNewLine + "Tekst zaszyfrowany:" + vbNewLine)
            textAfterEncription = encryptText(hiddenText, composedTable, True)
            displayFormatedText(textAfterEncription)
        Else
            Console.Write("Wprowad zaszyfrowany tekst: ")
            hiddenText = formatText(textFromConsole(), False)

            Console.Write("Wprowad haso: ")
            Dim klucz As String = Console.ReadLine()

            klucz = formatText(klucz, True)
            klucz = formatKey(klucz)
            Console.Write("Twoje haso po formatowaniu: " + klucz + vbNewLine)

            Console.Write(vbNewLine + "Tabela szyfrujca:" + vbNewLine)
            composedTable = generatePlayFairTable(klucz)

            displayTable()

            Console.Write(vbNewLine + "Tekst odszyfrowany:" + vbNewLine)
            textAfterDecription = encryptText(hiddenText, composedTable, False)

            displayFormatedText(textAfterDecription)
        End If
        Console.ReadLine()
    End Sub

    Private Function textFromConsole() As String
        'element ten suy do pobrania tekstu od uytkownika
        Dim tekstDoUkrycia = New StringBuilder()
        While True
            Dim cki As ConsoleKeyInfo = Console.ReadKey(True)
            Select Case cki.Key
                Case ConsoleKey.Enter
                    ' Koniec wprowadzania
                    Console.WriteLine()
                    Exit While
                Case ConsoleKey.Backspace
                    ' Uswanie ostatniego znaku
                    If tekstDoUkrycia.Length > 0 Then
                        tekstDoUkrycia.Remove(tekstDoUkrycia.Length - 1, 1)
                        Console.Write(vbBack & " " & vbBack)
                    End If
                Case Else
                    ' Dodaje znaki do zmiennej string
                    tekstDoUkrycia.Append(cki.KeyChar)
                    Console.Write(cki.KeyChar)
            End Select
        End While

        Return tekstDoUkrycia.ToString
    End Function

    Private Function formatText(text As String, isKey As Boolean) As String
        'formatuje nasz tekst, uswa spacje i zamienia wybrane elementy
        Dim formatedTekst As String = text.Trim.ToUpper
        formatedTekst = formatedTekst.Replace(" ", "")
        formatedTekst = formatedTekst.Replace(",", "")
        formatedTekst = formatedTekst.Replace("!", "")
        formatedTekst = formatedTekst.Replace("?", "")
        formatedTekst = formatedTekst.Replace("", "A")
        formatedTekst = formatedTekst.Replace("", "E")
        formatedTekst = formatedTekst.Replace("", "O")
        formatedTekst = formatedTekst.Replace("", "S")
        formatedTekst = formatedTekst.Replace("", "L")
        formatedTekst = formatedTekst.Replace("", "Z")
        formatedTekst = formatedTekst.Replace("", "Z")
        formatedTekst = formatedTekst.Replace("", "C")
        formatedTekst = formatedTekst.Replace("", "N")
        'ten element zasuguje na szczegln uwag poniewa jest odpowiedzialny za 
        'zamiane litery J na liter I
        formatedTekst = formatedTekst.Replace("J", "I")

        If isKey = False Then
StartOver:
            For i As Integer = 0 To formatedTekst.Length - 1
                If Not ((i + 1) Mod 2) = 0 Then
                    'nieparzysta litera 
                    'nie ostatnia
                    If Not i = formatedTekst.Length - 1 Then
                        'nastpna litera jest taka sama jak pierwsza
                        If formatedTekst(i) = formatedTekst(i + 1) Then
                            Select Case formatedTekst(i)
                            'jeli liter powtarzajc si jest X wtedy dodajemy Y
                                Case "X"
                                    formatedTekst = formatedTekst.Insert(i + 1, "Y")
                                    GoTo StartOver
                                Case Else
                                    formatedTekst = formatedTekst.Insert(i + 1, "X")
                                    GoTo StartOver
                            End Select
                        End If
                    Else
                        formatedTekst = formatedTekst.Insert(i + 1, "X")
                    End If
                End If
            Next
        End If
        Return formatedTekst
    End Function

    Private Function formatKey(key As String) As String
        'uswa powtarzajce si litery
        Dim formatedKey As String = ""
        For i As Integer = 0 To key.Length - 1
            If Not formatedKey.Contains(key(i)) Then
                formatedKey += key(i)
            End If
        Next
        Return formatedKey
    End Function

    Private Function generatePlayFairTable(key As String) As List(Of String)
        'zwraca sformatowan tabel poczon z kluczem
        Dim newTable As New List(Of String)
        newTable = startTable
        For i As Integer = key.Length - 1 To 0 Step -1
            For j As Integer = 0 To newTable.Count - 1
                If key(i) = newTable(j) Then
                    newTable.RemoveAt(j)
                    Exit For
                End If
            Next
            newTable.Insert(0, key(i))
        Next

        Return newTable
    End Function

    Private Sub displayFormatedText(text As String)
        'wywietla sformatowany tekst
        For i As Integer = 0 To text.Length - 1
            If ((i + 1) Mod 2) = 0 Then
                Console.Write(text(i - 1) + text(i)) ' + "-")
            End If
        Next
        Console.Write(vbNewLine)
    End Sub

    Private Sub displayTable()
        'wywietli tabele
        For i As Integer = 0 To composedTable.Count - 1
            Console.Write(composedTable(i) + ",")
            If ((i + 1) Mod 5) = 0 Then
                Console.Write(vbNewLine)
            End If
        Next
    End Sub

    Private Function encryptText(text As String, encryptTable As List(Of String), crypt As Boolean) As String
        'funkcja szyfrujca i deszyfrujca tekst
        Dim cryptedText As String = ""
        Dim myKeyArray(5, 5) As String

        Dim rowNum As Integer = 0
        Dim columnNum As Integer = 0

        For i As Integer = 0 To composedTable.Count - 1
            myKeyArray(rowNum, columnNum) = composedTable(i)
            columnNum += 1
            If ((i + 1) Mod 5) = 0 Then
                rowNum += 1
                columnNum = 0
            End If
        Next

        For i As Integer = 0 To text.Length - 1
            If ((i + 1) Mod 2) = 0 Then
                Dim indexOfFirstLetter As Integer() = indexOf(text(i - 1))
                Dim indexOfSecoundLetter As Integer() = indexOf(text(i))

                If indexOfFirstLetter(0) = indexOfSecoundLetter(0) Then
                    'Rwne wiersze
                    cryptedText += sameColumn(indexOfFirstLetter, indexOfSecoundLetter, myKeyArray, crypt)
                ElseIf indexOfFirstLetter(1) = indexOfSecoundLetter(1) Then
                    'Rwne kolumny
                    cryptedText += sameRow(indexOfFirstLetter, indexOfSecoundLetter, myKeyArray, crypt)
                Else
                    cryptedText += diffColumnRow(indexOfFirstLetter, indexOfSecoundLetter, myKeyArray, crypt)
                End If
            End If
        Next

        Return cryptedText
    End Function

    Private Function indexOf(letter As String) As Integer()
        'sprawdza indeks litery w tabeli
        Dim index As Integer = composedTable.IndexOf(letter) + 1
        Dim rowIndex = index Mod 5
        If rowIndex = 0 Then
            rowIndex = 5
        End If
        Return {rowIndex - 1, Math.Ceiling(index / 5) - 1}
    End Function

    Private Function sameRow(firstLetter As Integer(), secoundLetter As Integer(), keyArray(,) As String,
                             left As Boolean) As String
        'wiemy, e wiersze s rne wic naley przeprowadzi transformacje -1 w lewo
        'jeli kolumna ma index 0 wtedy bdzie to index 5
        Dim cipheredtext As String = ""
        Dim columnNum As Integer = firstLetter(1)

        If left = True Then
            'odszyfruj, jeden w prawo
            If firstLetter(0) + 1 > 4 Then
                cipheredtext += keyArray(columnNum, 0)
            Else
                cipheredtext += keyArray(columnNum, firstLetter(0) + 1)
            End If

            If secoundLetter(0) + 1 > 4 Then
                cipheredtext += keyArray(columnNum, 0)
            Else
                cipheredtext += keyArray(columnNum, secoundLetter(0) + 1)
            End If
        Else
            'szyfruj, jeden w lewo
            If firstLetter(0) - 1 < 0 Then
                cipheredtext += keyArray(columnNum, 4)
            Else
                cipheredtext += keyArray(columnNum, firstLetter(0) - 1)
            End If

            If secoundLetter(0) - 1 < 0 Then
                cipheredtext += keyArray(columnNum, 4)
            Else
                cipheredtext += keyArray(columnNum, secoundLetter(0) - 1)
            End If
        End If

        Return cipheredtext
    End Function

    Private Function sameColumn(firstLetter As Integer(), secoundLetter As Integer(), keyArray(,) As String,
            down As Boolean) As String
        'wiemy, e wiersze s rne wic naley przeprowadzi transformacje -1 w lewo
        'jeli kolumna ma index 0 wtedy bdzie to index 5
        Dim cipheredtext As String = ""
        Dim rowNum As Integer = firstLetter(0)
        If down = True Then
            'szyfruj, jedne w d
            If firstLetter(1) + 1 > 4 Then
                cipheredtext += keyArray(0, rowNum)
            Else
                cipheredtext += keyArray(firstLetter(1) + 1, rowNum)
            End If

            If secoundLetter(1) + 1 > 4 Then
                cipheredtext += keyArray(0, rowNum)
            Else
                cipheredtext += keyArray(secoundLetter(1) + 1, rowNum)
            End If
        Else
            'odszyfruj, jeden w gre
            If firstLetter(1) - 1 < 0 Then
                cipheredtext += keyArray(4, rowNum)
            Else
                cipheredtext += keyArray(firstLetter(1) - 1, rowNum)
            End If

            If secoundLetter(1) - 1 < 0 Then
                cipheredtext += keyArray(4, rowNum)
            Else
                cipheredtext += keyArray(secoundLetter(1) - 1, rowNum)
            End If
        End If

        Return cipheredtext
    End Function

    Private Function diffColumnRow(firstLetter As Integer(), secoundLetter As Integer(), keyArray(,) As String,
            crypt As Boolean) As String
        Dim cipheredtext As String = ""
        If crypt = True Then
            'szyfruj
            cipheredtext += keyArray(firstLetter(1), secoundLetter(0))
            cipheredtext += keyArray(secoundLetter(1), firstLetter(0))
        Else
            'odszyfruj
            cipheredtext += keyArray(firstLetter(1), secoundLetter(0))
            cipheredtext += keyArray(secoundLetter(1), firstLetter(0))
        End If

        Return cipheredtext
    End Function

End Module
